<?php

	require_once('../lib/config.php');
	require_once('Smarty.class.php');
	require_once('Forms.class.php');
	require_once('Functions.class.php');
	require_once('Error.class.php');
	require_once('User.class.php');
	require_once('Mailer.class.php');
	require_once('Utils.class.php');
	require_once('HtPasswd.class.php');

	if(!isset($_REQUEST['action'])){
		$_REQUEST['action']='regform';
	}

	switch ($_REQUEST['action']){

		case 'edit':
			require_once('auth_db.php');
			$ht = new HtPasswd( SITE_DOC_ROOT . '/members/.htpasswd');
			$user_id = User::idFromEmail($_SERVER['PHP_AUTH_USER']);
			$user = new User($user_id);
			$smarty = new Smarty();
			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
			$smarty->assign('user', $user);
			$smarty->assign('has_access', $ht->isUser($_SERVER['PHP_AUTH_USER']));
			$smarty->assign('states', Forms::statesArray());
			$smarty->assign('countries', Forms::countriesArray());
			$smarty->assign('action', 'update');
			$smarty->assign('period1_active', PERIOD1_ACTIVE);
			$smarty->assign('period1_value', PERIOD1_VALUE);
			$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
			$smarty->assign('amount1', AMOUNT1);
			$smarty->assign('period2_active', PERIOD2_ACTIVE);
			$smarty->assign('period2_value', PERIOD2_VALUE);
			$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
			$smarty->assign('amount2', AMOUNT2);
			$smarty->assign('period3_value', PERIOD3_VALUE);
			$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
			$smarty->assign('amount3', AMOUNT3);
			$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
		break;


		case 'insert':
			$err = 0;

			// Clean up the passwords
			$_POST['user_password']              = trim($_POST['user_password']);
			$_POST['user_password_confirmation'] = trim($_POST['user_password_confirmation']);

			$user = new User();
			$user->user_firstname        = $_POST['user_firstname'];
			$user->user_lastname         = $_POST['user_lastname'];
			$user->user_email            = $_POST['user_email'];
			$user->user_password		 = $_POST['user_password'];
			$user->user_telephone        = $_POST['user_telephone'];
			$user->user_fax              = $_POST['user_fax'];
			$user->user_address          = $_POST['user_address'];
			$user->user_address2         = $_POST['user_address2'];
			$user->user_city             = $_POST['user_city'];
			$user->user_state            = $_POST['user_state'];
			$user->user_country          = $_POST['user_country'];
			$user->user_postcode         = $_POST['user_postcode'];

			$msg = '';

			// Validate data
			$err = $user->validateRegForm();
			if($err > 0){
				$msg .= $err>1?"Some required fields need correction":"A required field needs correction";
			}

			if($_POST['user_password'] != $_POST['user_password_confirmation']){
				$err++;
				$msg .= '<br />Passwords do not match';
			} elseif(strlen(trim($_POST['user_password'])) < 5){
				$err++;
				$msg .= '<br />Password is too short';
			}

			$smarty = new Smarty();
 			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
			if($err > 0){
				$smarty->assign('msg', $err>1?"Some required fields need correction":"A required field needs correction");
				$smarty->assign('user', $user);
				$smarty->assign('states', Forms::statesArray());
				$smarty->assign('countries', Forms::countriesArray());
				$smarty->assign('action', 'insert');
				$smarty->assign('period1_active', PERIOD1_ACTIVE);
				$smarty->assign('period1_value', PERIOD1_VALUE);
				$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
				$smarty->assign('amount1', AMOUNT1);
				$smarty->assign('period2_active', PERIOD2_ACTIVE);
				$smarty->assign('period2_value', PERIOD2_VALUE);
				$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
				$smarty->assign('amount2', AMOUNT2);
				$smarty->assign('period3_value', PERIOD3_VALUE);
				$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
				$smarty->assign('amount3', AMOUNT3);
				$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
				$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
				$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
				exit();
			}


			//  Everything is good. Insert the user.
			$user->insertUser();
			if($user->err_no != 0){
				if($user->err_no == 1062){
					$smarty->assign('msg', 'E-mail adress already registered. <a href="index.php?action=sendpw">Click here if you would like to us to email a password reminder</a>.');
					$smarty->assign('user', $user);
					$smarty->assign('states', Forms::statesArray());
					$smarty->assign('countries', Forms::countriesArray());
					$smarty->assign('action', 'insert');
					$smarty->assign('period1_active', PERIOD1_ACTIVE);
					$smarty->assign('period1_value', PERIOD1_VALUE);
					$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
					$smarty->assign('amount1', AMOUNT1);
					$smarty->assign('period2_active', PERIOD2_ACTIVE);
					$smarty->assign('period2_value', PERIOD2_VALUE);
					$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
					$smarty->assign('amount2', AMOUNT2);
					$smarty->assign('period3_value', PERIOD3_VALUE);
					$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
					$smarty->assign('amount3', AMOUNT3);
					$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
					exit();
				}else{
					Error::errorMsg($user->err_msg);
				}
				exit();
			}
			// Send mail to autoresponder
			if(AUTORESPOND_ACTIVE != 0){
				$mail = new Mailer();
				$mail->from    = $user->user_firstname . ' ' . $user->user_lastname . ' <' . $user->user_email . '>';
				$mail->to      = AUTORESPOND_TO;
				$mail->subject = AUTORESPOND_SUBJECT;
				$mail->msg     = AUTORESPOND_BODY;
				$mail->send();	
			}
			header('Location: index.php?action=pay&user_id=' . $user->user_id. '&user_membership=' . $_POST['user_membership']);
		break;


		case 'pay':
			if(!isset($_REQUEST['user_id'])){
				Error::errorMsg('Unable to determine user id');
			}
			if(!isset($_REQUEST['user_membership'])){
				Error::errorMsg('Unable to determine membership');
			}
			$user = new User($_REQUEST['user_id']);
			$user->user_telephone = Utils::parsePhone($user->user_telephone);
			$smarty = new Smarty();
 			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
			$smarty->assign('user', $user);
			$smarty->assign('action_url', PAYPAL_URL);
			$smarty->assign('paypal_account', PAYPAL_ACCOUNT);
			switch($_REQUEST['user_membership']){
				case 'period1':
					  $smarty->assign('membership_name', SITE_NAME . ' ' . PERIOD1_VALUE . ' ' . Forms::interval2String(PERIOD1_INTERVAL) . ' ' . ' Trial Membership');
					  $smarty->assign('membership_id', 'Period1');
				break;

				case 'period2':
				 	$smarty->assign('membership_name', SITE_NAME . ' ' . PERIOD2_VALUE . ' ' . Forms::interval2String(PERIOD2_INTERVAL) . ' ' . ' Trial Membership');
					$smarty->assign('membership_id', 'Period2');
				 break;

				case 'period3':
					 $smarty->assign('membership_name', SITE_NAME . ' ' . PERIOD3_VALUE . ' ' . Forms::interval2String(PERIOD3_INTERVAL) . ' ' . ' Renewable Membership');
					 $smarty->assign('membership_id', 'Period3');
				break;

			}
			$smarty->assign('a1', AMOUNT1);
			$smarty->assign('p1', PERIOD1_VALUE);
			$smarty->assign('t1', PERIOD1_INTERVAL);
			$smarty->assign('a2', AMOUNT2);
			$smarty->assign('p2', PERIOD2_VALUE);
			$smarty->assign('t2', PERIOD2_INTERVAL);
			$smarty->assign('a3', AMOUNT3);
			$smarty->assign('p3', PERIOD3_VALUE);
			$smarty->assign('t3', PERIOD3_INTERVAL);
			$smarty->assign('paypal_return_url', PAYPAL_RETURN_URL);
			$smarty->assign('paypal_cancel_url', PAYPAL_CANCEL_URL);
			$smarty->assign('paypal_notify_url', 'http://' . $_SERVER['HTTP_HOST'] . SITE_URL_ROOT . '/paypal/ipn.php');
			$smarty->assign('paypal_icon', PAYPAL_ICON);
			$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/payment.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
		break;


		case 'update':
			require_once('auth_db.php');

			$err = 0;

			// Clean up the passwords
			$_POST['user_password']              = trim($_POST['user_password']);
			$_POST['user_password_confirmation'] = trim($_POST['user_password_confirmation']);

			$user_id = User::idFromEmail($_SERVER['PHP_AUTH_USER']);
			if($user_id < 1){
				Error::errorMsg('Unable to determine user id');
			}
			$user = new User($user_id);
			$old_email = $user->user_email;
			$user->user_firstname        = $_POST['user_firstname'];
			$user->user_lastname         = $_POST['user_lastname'];
			$user->user_email            = $_POST['user_email'];
			$user->user_telephone        = $_POST['user_telephone'];
			$user->user_fax              = $_POST['user_fax'];
			$user->user_address          = $_POST['user_address'];
			$user->user_address2         = $_POST['user_address2'];
			$user->user_city             = $_POST['user_city'];
			$user->user_state            = $_POST['user_state'];
			$user->user_country			 = $_POST['user_country'];
			$user->user_postcode         = $_POST['user_postcode'];

			// Validate data
			$err = $user->validateRegForm();
			$smarty = new Smarty();
 			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';

			if($err > 0){
				$smarty->assign('msg', $err>1?"Some required fields need correction":"A required field needs correction");
				$smarty->assign('user', $user);
				$smarty->assign('has_access', $ht->isUser($user->user_email));
				$smarty->assign('states', Forms::statesArray());
				$smarty->assign('countries', Forms::countriesArray());
				$smarty->assign('action', 'update');
				$smarty->assign('period1_active', PERIOD1_ACTIVE);
				$smarty->assign('period1_value', PERIOD1_VALUE);
				$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
				$smarty->assign('amount1', AMOUNT1);
				$smarty->assign('period2_active', PERIOD2_ACTIVE);
				$smarty->assign('period2_value', PERIOD2_VALUE);
				$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
				$smarty->assign('amount2', AMOUNT2);
				$smarty->assign('period3_value', PERIOD3_VALUE);
				$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
				$smarty->assign('amount3', AMOUNT3);
				$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
				$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
				$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
				exit();
			}

			if($_POST['user_password']!=''){
				if($_POST['user_password'] != $_POST['user_password_confirmation']){
					$err = -1;
				} elseif(strlen(trim($_POST['user_password'])) < 5){
					$err = -2;
				}

				// Passwords do not match or too short
				if($err < 0){
					if($err == -1){
						$smarty->assign('msg', 'Passwords do not match');
					} else {
						$smarty->assign('msg', 'Password is too short');
					}
					$smarty->assign('user', $user);
					$smarty->assign('has_access', $ht->isUser($user->user_email));
					$smarty->assign('states', Forms::statesArray());
					$smarty->assign('countries', Forms::countriesArray());
					$smarty->assign('action', 'update');
					$smarty->assign('period1_active', PERIOD1_ACTIVE);
					$smarty->assign('period1_value', PERIOD1_VALUE);
					$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
					$smarty->assign('amount1', AMOUNT1);
					$smarty->assign('period2_active', PERIOD2_ACTIVE);
					$smarty->assign('period2_value', PERIOD2_VALUE);
					$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
					$smarty->assign('amount2', AMOUNT2);
					$smarty->assign('period3_value', PERIOD3_VALUE);
					$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
					$smarty->assign('amount3', AMOUNT3);
					$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
					exit();
				}
				$user->user_password = $_POST['user_password'];
			}

			$user->updateUser();
			$ht = new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');

			if($user->err_no != 0){
				if($user->err_no == 1062){
					$smarty->assign('msg', 'E-mail adress already registered. <a href="index.php?action=resetpw">Click here if you would like to reset your password</a>.');
					$smarty->assign('user', $user);
					$smarty->assign('has_access', $ht->isUser($user->user_email));
					$smarty->assign('states', Forms::statesArray());
					$smarty->assign('countries', Forms::countriesArray());
					$smarty->assign('action', 'update');
					$smarty->assign('period1_active', PERIOD1_ACTIVE);
					$smarty->assign('period1_value', PERIOD1_VALUE);
					$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
					$smarty->assign('amount1', AMOUNT1);
					$smarty->assign('period2_active', PERIOD2_ACTIVE);
					$smarty->assign('period2_value', PERIOD2_VALUE);
					$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
					$smarty->assign('amount2', AMOUNT2);
					$smarty->assign('period3_value', PERIOD3_VALUE);
					$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
					$smarty->assign('amount3', AMOUNT3);
					$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
					$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
					exit();
				} else {
					Error::errorMsg($user->err_msg);
					exit();
				}
			}

			if(!$ht->isUser($old_email)){
				header('Location: index.php?action=pay&user_id=' . $user->user_id. '&user_membership=' . $_POST['user_membership']);
				exit();
			} else {
				if($_POST['user_password']!=''){
					$ht->deleteUser($old_email);
					$ht->addUser($user->user_email, $_POST['user_password']);
				}
			}
			Functions::redirectMsg('Registration Updated', 'index.php?action=edit');
		break;


		case 'sendpw':
 			$smarty = new Smarty();
 			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
			if(isset($_POST['email'])){
				$_POST['email'] = trim($_POST['email']);
				if($_POST['email']==''){
					$smarty->assign('msg', 'E-mail address must not be blank');
				} elseif (!$id = User::idFromEmail($_POST['email'])){
					$smarty->assign('msg', 'Unknown e-mail address.');
				}else{
					$user = new User($id);
					$smarty->assign('user', $user);
					$msg = $smarty->fetch(SITE_DOC_ROOT .  '/templates/send_pw_mail_msg.tpl');
					$mail = new Mailer();
					$mail->to = $user->user_firstname . ' ' . $user->user_lastname . '<' . $user->user_email . '>';
					$mail->subject = 'Password reminder for ' . SITE_NAME;
					$mail->msg = $msg;
					$mail->send();
					Functions::redirectMsg('Your password has been sent.<br>It should arrive in your e-mail shortly.', SITE_URL, '', 5, false);
					exit();
				}
			}
			$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
			$smarty->display(SITE_DOC_ROOT .  '/templates/send_pw.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
		break;

		case 'regform':
		default:
			$user = new User();
 			$smarty = new Smarty();
 			$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
			$smarty->assign('user', $user);
			$smarty->assign('has_access', false);
			$smarty->assign('states', Forms::statesArray());
			$smarty->assign('countries', Forms::countriesArray());
			$smarty->assign('action', 'insert');
			$smarty->assign('period1_active', PERIOD1_ACTIVE);
			$smarty->assign('period1_value', PERIOD1_VALUE);
			$smarty->assign('period1_interval', Forms::interval2String(PERIOD1_INTERVAL));
			$smarty->assign('amount1', AMOUNT1);
			$smarty->assign('period2_active', PERIOD2_ACTIVE);
			$smarty->assign('period2_value', PERIOD2_VALUE);
			$smarty->assign('period2_interval', Forms::interval2String(PERIOD2_INTERVAL));
			$smarty->assign('amount2', AMOUNT2);
			$smarty->assign('period3_value', PERIOD3_VALUE);
			$smarty->assign('period3_interval', Forms::interval2String(PERIOD3_INTERVAL));
			$smarty->assign('amount3', AMOUNT3);
			$smarty->display(SITE_DOC_ROOT . '/templates/head.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/user_edit.tpl');
			$smarty->display(SITE_DOC_ROOT . '/templates/foot.tpl');
		break;


	}

?>